Package org.apache.commons.math3.ode.nonstiff

# Class EmbeddedRungeKuttaFieldIntegrator<T extends RealFieldElement<T>>

java.lang.Object
org.apache.commons.math3.ode.AbstractFieldIntegrator<T>
org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeFieldIntegrator<T>
org.apache.commons.math3.ode.nonstiff.EmbeddedRungeKuttaFieldIntegrator<T>

Type Parameters:
  `T` - the type of the field elements

All Implemented Interfaces:
  `FirstOrderFieldIntegrator<T>`, `FieldButcherArrayProvider<T>`

Direct Known Subclasses:
  `DormandPrince54FieldIntegrator`, `DormandPrince853FieldIntegrator`, `HighamHall54FieldIntegrator`

public abstract class EmbeddedRungeKuttaFieldIntegrator<T extends RealFieldElement<T>> extends AdaptiveStepsizeFieldIntegrator<T> implements FieldButcherArrayProvider<T>
This class implements the common part of all embedded Runge-Kutta integrators for Ordinary Differential Equations.

These methods are embedded explicit Runge-Kutta methods with two sets of coefficients allowing to estimate the error, their Butcher arrays are as follows :

        0  |
       c2  | a21
       c3  | a31  a32
       ... |        ...
       cs  | as1  as2  ...  ass-1
           |--------------------------
           |  b1   b2  ...   bs-1  bs
           |  b'1  b'2 ...   b's-1 b's

In fact, we rather use the array defined by ej = bj - b'j to compute directly the error rather than computing two estimates and then comparing them.

Some methods are qualified as fsal (first same as last) methods. This means the last evaluation of the derivatives in one step is the same as the first in the next step. Then, this evaluation can be reused from one step to the next one and the cost of such a method is really s-1 evaluations despite the method still has s stages. This behaviour is true only for successful steps, if the step is rejected after the error estimation phase, no evaluation is saved. For an fsal method, we have cs = 1 and asi = bi for all i.

Since:
  3.6

## Field Summary

### Fields inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeFieldIntegrator

`mainSetDimension, scalAbsoluteTolerance, scalRelativeTolerance, vecAbsoluteTolerance, vecRelativeTolerance`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`EmbeddedRungeKuttaFieldIntegrator(Field<T> field, String name, int fsal, double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)`
Build a Runge-Kutta integrator with the given Butcher array.
`protected`
`EmbeddedRungeKuttaFieldIntegrator(Field<T> field, String name, int fsal, double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)`
Build a Runge-Kutta integrator with the given Butcher array.

## Method Summary

Modifier and Type
Method
Description
`protected abstract org.apache.commons.math3.ode.nonstiff.RungeKuttaFieldStepInterpolator<T>`
`createInterpolator(boolean forward, T[][] yDotK, FieldODEStateAndDerivative<T> globalPreviousState, FieldODEStateAndDerivative<T> globalCurrentState, FieldEquationsMapper<T> mapper)`
Create an interpolator.
`protected abstract T`
`estimateError(T[][] yDotK, T[] y0, T[] y1, T h)`
Compute the error ratio.
`protected T`
`fraction(double p, double q)`
Create a fraction.
`protected T`
`fraction(int p, int q)`
Create a fraction.
`T`
`getMaxGrowth()`
Get the maximal growth factor for stepsize control.
`T`
`getMinReduction()`
Get the minimal reduction factor for stepsize control.
`abstract int`
`getOrder()`
Get the order of the method.
`T`
`getSafety()`
Get the safety factor for stepsize control.
`FieldODEStateAndDerivative<T>`
`integrate(FieldExpandableODE<T> equations, FieldODEState<T> initialState, T finalTime)`
Integrate the differential equations up to the given time.
`void`
`setMaxGrowth(T maxGrowth)`
Set the maximal growth factor for stepsize control.
`void`
`setMinReduction(T minReduction)`
Set the minimal reduction factor for stepsize control.
`void`
`setSafety(T safety)`
Set the safety factor for stepsize control.

### Methods inherited from class org.apache.commons.math3.ode.nonstiff.AdaptiveStepsizeFieldIntegrator

`filterStep, getMaxStep, getMinStep, initializeStep, resetInternalState, sanityChecks, setInitialStepSize, setStepSizeControl, setStepSizeControl`

### Methods inherited from class org.apache.commons.math3.ode.AbstractFieldIntegrator

`acceptStep, addEventHandler, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, computeDerivatives, getCurrentSignedStepsize, getCurrentStepStart, getEquations, getEvaluations, getEvaluationsCounter, getEventHandlers, getField, getMaxEvaluations, getName, getStepHandlers, getStepSize, getStepStart, initIntegration, isLastStep, resetOccurred, setIsLastStep, setMaxEvaluations, setStateInitialized, setStepSize, setStepStart`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.commons.math3.ode.nonstiff.FieldButcherArrayProvider

`getA, getB, getC`

## Constructor Details

### EmbeddedRungeKuttaFieldIntegrator

protected EmbeddedRungeKuttaFieldIntegrator(Field<T> field, String name, int fsal, double minStep, double maxStep, double scalAbsoluteTolerance, double scalRelativeTolerance)
Build a Runge-Kutta integrator with the given Butcher array.

Parameters:
  `field` - field to which the time and state vector elements belong
  `name` - name of the method
  `fsal` - index of the pre-computed derivative for fsal methods or -1 if method is not fsal
  `minStep` - minimal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `maxStep` - maximal step (sign is irrelevant, regardless of integration direction, forward or backward), the last step can be smaller than this
  `scalAbsoluteTolerance` - allowed absolute error
  `scalRelativeTolerance` - allowed relative error

### EmbeddedRungeKuttaFieldIntegrator

protected EmbeddedRungeKuttaFieldIntegrator(Field<T> field, String name, int fsal, double minStep, double maxStep, double[] vecAbsoluteTolerance, double[] vecRelativeTolerance)
Build a Runge-Kutta integrator with the given Butcher array.

Parameters:
  `field` - field to which the time and state vector elements belong
  `name` - name of the method
  `fsal` - index of the pre-computed derivative for fsal methods or -1 if method is not fsal
  `minStep` - minimal step (must be positive even for backward integration), the last step can be smaller than this
  `maxStep` - maximal step (must be positive even for backward integration)
  `vecAbsoluteTolerance` - allowed absolute error
  `vecRelativeTolerance` - allowed relative error

## Method Details

### fraction

protected T fraction(int p, int q)
Create a fraction.

Parameters:
  `p` - numerator
  `q` - denominator
Returns:
  p/q computed in the instance field

### fraction

protected T fraction(double p, double q)
Create a fraction.

Parameters:
  `p` - numerator
  `q` - denominator
Returns:
  p/q computed in the instance field

### createInterpolator

protected abstract org.apache.commons.math3.ode.nonstiff.RungeKuttaFieldStepInterpolator<T> createInterpolator(boolean forward, T[][] yDotK, FieldODEStateAndDerivative<T> globalPreviousState, FieldODEStateAndDerivative<T> globalCurrentState, FieldEquationsMapper<T> mapper)
Create an interpolator.

Parameters:
  `forward` - integration direction indicator
  `yDotK` - slopes at the intermediate points
  `globalPreviousState` - start of the global step
  `globalCurrentState` - end of the global step
  `mapper` - equations mapper for the all equations
Returns:
  external weights for the high order method from Butcher array

### getOrder

public abstract int getOrder()
Get the order of the method.

Returns:
  order of the method

### getSafety

public T getSafety()
Get the safety factor for stepsize control.

Returns:
  safety factor

### setSafety

public void setSafety(T safety)
Set the safety factor for stepsize control.

Parameters:
  `safety` - safety factor

### integrate

public FieldODEStateAndDerivative<T> integrate(FieldExpandableODE<T> equations, FieldODEState<T> initialState, T finalTime) throws NumberIsTooSmallException, DimensionMismatchException, MaxCountExceededException, NoBracketingException
Integrate the differential equations up to the given time.

This method solves an Initial Value Problem (IVP).

Since this method stores some internal state variables made available in its public interface during integration (`FirstOrderFieldIntegrator.getCurrentSignedStepsize()`), it is not thread-safe.

Specified by:
  `integrate` in interface `FirstOrderFieldIntegrator<T extends RealFieldElement<T>>`
Parameters:
  `equations` - differential equations to integrate
  `initialState` - initial state (time, primary and secondary state vectors)
  `finalTime` - target time for the integration (can be set to a value smaller than `t0` for backward integration)
Returns:
  final state, its time will be the same as `finalTime` if integration reached its target, but may be different if some `FieldEventHandler` stops it at some point.
Throws:
  `NumberIsTooSmallException` - if integration step is too small
  `MaxCountExceededException` - if the number of functions evaluations is exceeded
  `NoBracketingException` - if the location of an event cannot be bracketed
  `DimensionMismatchException`

### getMinReduction

public T getMinReduction()
Get the minimal reduction factor for stepsize control.

Returns:
  minimal reduction factor

### setMinReduction

public void setMinReduction(T minReduction)
Set the minimal reduction factor for stepsize control.

Parameters:
  `minReduction` - minimal reduction factor

### getMaxGrowth

public T getMaxGrowth()
Get the maximal growth factor for stepsize control.

Returns:
  maximal growth factor

### setMaxGrowth

public void setMaxGrowth(T maxGrowth)
Set the maximal growth factor for stepsize control.

Parameters:
  `maxGrowth` - maximal growth factor

### estimateError

protected abstract T estimateError(T[][] yDotK, T[] y0, T[] y1, T h)
Compute the error ratio.

Parameters:
  `yDotK` - derivatives computed during the first stages
  `y0` - estimate of the step at the start of the step
  `y1` - estimate of the step at the end of the step
  `h` - current step
Returns:
  error ratio, greater than 1 if step should be rejected